package	jp.co.sds_corp.util.jmx.rmi.server;

import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.naming.InitialContext;

import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.jmx.AbstractMBeanService;
import jp.co.sds_corp.util.log.CmnLogger;

public class JMXAdaptorService extends AbstractMBeanService
			implements JMXAdaptorServiceMBean
{
	static CmnLogger logger = CmnLogger.getInstance();
	public static String JNDI_NAME = "jp.co.sds_corp.util.jmx";

	MBeanServer server;
	JMXAdaptorImpl adaptor;

	public ObjectName getObjectName(MBeanServer server, ObjectName name)
		throws javax.management.MalformedObjectNameException
	{
		this.server = server;
		return new ObjectName(OBJECT_NAME);
	}

	public String getName() {
		return "JMX RMI Adaptor";
	}

	public void initService( IConfiguration config ) throws Exception {
		adaptor = new JMXAdaptorImpl(server);
	}

	public void startService() throws Exception {
		new InitialContext().bind(JNDI_NAME, adaptor);
	}

	public void stopService() {
		try {
			new InitialContext().unbind(JNDI_NAME);
		} catch (Exception e) {
			logger.error( this,"unbind failure", e);
		}
	}
}


